package com.ygtx.worklog.service.impl;

import java.util.List;

import com.ygtx.worklog.domain.SystemConfig;
import com.ygtx.worklog.mapper.SystemConfigMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ygtx.common.utils.DateUtils;
import com.ygtx.common.utils.SecurityUtils;
import com.ygtx.worklog.service.ISystemConfigService;

/**
 * 系统配置Service业务层处理
 *
 * @author ruoyi
 * @date 2025-10-21
 */
@Service
public class SystemConfigServiceImpl implements ISystemConfigService
{
    @Autowired
    private SystemConfigMapper systemConfigMapper;

    /**
     * 查询系统配置
     *
     * @param id 系统配置主键
     * @return 系统配置
     */
    @Override
    public SystemConfig selectSystemConfigById(Long id)
    {
        return systemConfigMapper.selectSystemConfigById(id);
    }

    /**
     * 查询系统配置列表
     *
     * @param systemConfig 系统配置
     * @return 系统配置
     */
    @Override
    public List<SystemConfig> selectSystemConfigList(SystemConfig systemConfig)
    {
        return systemConfigMapper.selectSystemConfigList(systemConfig);
    }

    /**
     * 新增系统配置
     *
     * @param systemConfig 系统配置
     * @return 结果
     */
    @Override
    public int insertSystemConfig(SystemConfig systemConfig)
    {
        systemConfig.setCreateTime(DateUtils.getNowDate());
        systemConfig.setCreateBy(SecurityUtils.getUsername());
        return systemConfigMapper.insertSystemConfig(systemConfig);
    }

    /**
     * 修改系统配置
     *
     * @param systemConfig 系统配置
     * @return 结果
     */
    @Override
    public int updateSystemConfig(SystemConfig systemConfig)
    {
        systemConfig.setUpdateTime(DateUtils.getNowDate());
        systemConfig.setUpdateBy(SecurityUtils.getUsername());
        return systemConfigMapper.updateSystemConfig(systemConfig);
    }

    /**
     * 批量删除系统配置
     *
     * @param ids 需要删除的系统配置主键
     * @return 结果
     */
    @Override
    public int deleteSystemConfigByIds(Long[] ids)
    {
        return systemConfigMapper.deleteSystemConfigByIds(ids);
    }

    /**
     * 删除系统配置信息
     *
     * @param id 系统配置主键
     * @return 结果
     */
    @Override
    public int deleteSystemConfigById(Long id)
    {
        return systemConfigMapper.deleteSystemConfigById(id);
    }

    /**
     * 根据配置键查询配置值
     *
     * @param configKey 配置键
     * @return 配置值
     */
    @Override
    public String selectConfigByKey(String configKey)
    {
        SystemConfig config = systemConfigMapper.selectSystemConfigByKey(configKey);
        return config != null ? config.getConfigValue() : null;
    }
}
